#include "voti.h"

voto * leggi_voti(char *nfile, int *n) {
    /* apro il file */
    FILE *fp = fopen(nfile, "r");
    if(fp == NULL) {
        fprintf(stderr, "Impossibile aprire %s\n", nfile);
        exit(1);
    }

    /* conto il numero di elementi da leggere */
    *n = 0;
    voto t;
    while(fscanf(fp, "%s%d", t.matricola, &t.voto) == 2) (*n)++;;

    /* alloco dinamicamente il vettore */
    voto *res = (voto*) malloc((*n) * sizeof(voto));

    /* riporto il cursore alla posizione iniziale */
    rewind(fp);

    /* leggo i dati */
    for(int i = 0; i < *n; ++i)
        fscanf(fp, "%s%d", res[i].matricola, &res[i].voto);

    /* chiudo il file */
    fclose(fp);

    /* restituisco un puntatore all'array */
    return res;
}

