#include "persone.h"

persona * leggi_persone(char *nfile, int *n) {
    /* apro il file */
    FILE *fp = fopen(nfile, "r");
    if(fp == NULL) {
        fprintf(stderr, "Impossibile aprire %s\n", nfile);
        exit(1);
    }

    /* leggo il numero di elementi */
    if (fscanf(fp, "%d", n) != 1) {
        fprintf(stderr, "Impossibile leggere il numero di elementi\n");
        exit(1);
    }

    /* alloco dinamicamente il vettore */
    persona *res = (persona*) malloc((*n) * sizeof(persona));

    /* leggo i dati */
    for(int i = 0; i < *n; ++i)
        fscanf(fp, "%s%s", res[i].nome, res[i].cognome);

    /* chiudo il file */
    fclose(fp);

    /* restituisco un puntatore all'array */
    return res;
}

